leetcode 452. Minimum Number of Arrows to Burst Balloons (Python)

13 Jul 2020 Leetcode Greedy

452. Minimum Number of Arrows to Burst Balloons (Python)

Greedy.

Description

There are a number of spherical balloons spread in two-dimensional space. For each balloon, provided input is the start and end coordinates of the horizontal diameter. Since it’s horizontal, y-coordinates don’t matter and hence the x-coordinates of start and end of the diameter suffice. Start is always smaller than end. There will be at most 104 balloons.

An arrow can be shot up exactly vertically from different points along the x-axis. A balloon with xstart and xend bursts by an arrow shot at x if xstart ≤ x ≤ xend. There is no limit to the number of arrows that can be shot. An arrow once shot keeps travelling up infinitely. The problem is to find the minimum number of arrows that must be shot to burst all balloons.

Sample I/O

Example 1

Input:
[[10,16], [2,8], [1,6], [7,12]]

Output:
2

Explanation:
One way is to shoot one arrow for example at x = 6 (bursting the balloons [2,8] and [1,6]) and another arrow at x = 11 (bursting the other two balloons).

Methodology

We use greedy to solve this question. We sort the given input list by end time. We set a left boundary and Now we only need to compare the current start time and previous end time. If the current start time is greater than previous end time. Then we now we need one more arrow and we have to update the previous end time to current end time. Otherwise the current and previous ballons can be bursted by one arrow.

if not points: return 0
        points.sort(key=lambda x: x[1])
        first_end = points[0][1]
        arrow = 1
        for i in range(1,len(points)):
            start, end = points[i]
            if start > first_end:
                arrow+=1
                first_end = end
        return arrow

BigO

Time complexity : O(nlogn) because sorting inpur data, where n is the size of input.

Search

    Table of Contents